package org.seasar.remoting.axis.connector;

import java.lang.reflect.Method;
import java.net.URL;

import javax.xml.namespace.QName;
import javax.xml.rpc.Call;
import javax.xml.rpc.Service;
import javax.xml.rpc.encoding.TypeMapping;

import org.apache.axis.constants.Use;
import org.apache.axis.encoding.TypeMappingDelegate;
import org.apache.axis.encoding.TypeMappingRegistry;
import org.seasar.remoting.axis.S2AxisConstants;
import org.seasar.remoting.common.connector.impl.TargetSpecificURLBasedConnector;

/**
 * WebT[rXĂяoRlN^̎NXłB
 * 
 * @author koichik
 */
public class AxisConnector extends TargetSpecificURLBasedConnector {
    protected Service service;

    /**
     * AxisT[rXݒ肵܂B
     * 
     * @param service
     *            AxisT[rX
     */
    public void setService(final Service service) {
        this.service = service;

        final TypeMappingRegistry tmr = (TypeMappingRegistry) service.getTypeMappingRegistry();
        TypeMapping tm = tmr.getTypeMapping(Use.DEFAULT.getEncoding());
        ((TypeMappingDelegate) tm).setDoAutoTypes(true);
    }

    /**
     * AxisT[rXgpă[g\bȟĂяosǍʂԂ܂B
     * 
     * @param targetURL
     *            [gIuWFNgURL
     * @param method
     *            Ăяo\bh
     * @param args
     *            [gIuWFNg̃\bhĂяoɓnli[IuWFNgz
     * @return [gIuWFNgɑ΂郁\bhĂяo̖߂l
     * @throws Throwable
     *             [gIuWFNgɑ΂郁\bhĂяoX[O
     */
    protected Object invoke(final URL targetURL, final Method method, final Object[] args)
            throws Throwable {
        final Call call = service.createCall();
        call.setTargetEndpointAddress(targetURL.toString());
        call.setOperationName(new QName(S2AxisConstants.OPERATION_NAMESPACE_URI, method.getName()));
        return call.invoke(args);
    }
}